=== modified file 'linaro_image_tools/media_create/android_boards.py'
--- linaro_image_tools/media_create/android_boards.py	2012-09-20 08:08:10 +0000
+++ linaro_image_tools/media_create/android_boards.py	2012-10-17 10:48:49 +0000
@@ -84,6 +84,8 @@
         # comes from - and lives in the same directory in the boot tarball, so
         # here we don't need to pass the whole path to it.
         boot_env["bootcmd"] = cls._get_bootcmd(initrd, cls.dtb_name)
+        boot_env["initrd_high"] = cls.initrd_high
+        boot_env["fdt_high"] = cls.fdt_high
         return boot_env
 
     @classmethod
@@ -204,7 +206,9 @@
 
 class AndroidSnowballSdConfig(AndroidBoardConfig, SnowballSdConfig):
     boot_script = 'boot.scr'
+    fdt_high = '0x05000000'
     initrd_addr = '0x05000000'
+    initrd_high = '0x06000000'
     extra_boot_args_options = (
         'earlyprintk mem=128M@0 mali.mali_mem=64M@128M hwmem=168M@192M '
         'mem=22M@360M mem_issw=1M@383M mem=640M@384M vmalloc=500M')
@@ -216,7 +220,9 @@
 
 class AndroidSnowballEmmcConfig(AndroidBoardConfig, SnowballEmmcConfig):
     boot_script = 'boot.scr'
+    fdt_high = '0x05000000'
     initrd_addr = '0x05000000'
+    initrd_high = '0x06000000'
     extra_boot_args_options = (
         'earlyprintk mem=128M@0 mali.mali_mem=64M@128M hwmem=168M@192M '
         'mem=22M@360M mem_issw=1M@383M mem=640M@384M vmalloc=500M')

=== modified file 'linaro_image_tools/media_create/boards.py'
--- linaro_image_tools/media_create/boards.py	2012-10-09 14:39:52 +0000
+++ linaro_image_tools/media_create/boards.py	2012-10-12 12:40:11 +0000
@@ -403,10 +403,12 @@
     # be specified in the hwpack metadata.
     kernel_addr = None
     initrd_addr = None
+    initrd_high = '0xffffffff'
     load_addr = None
     dtb_addr = None
     dtb_name = None
     dtb_file = None
+    fdt_high = '0xffffffff'
     kernel_flavors = None
     boot_script = None
     serial_tty = None
@@ -841,6 +843,8 @@
         boot_env["bootargs"] = cls._get_bootargs(
             is_live, is_lowmem, consoles, rootfs_id)
         boot_env["bootcmd"] = cls._get_bootcmd(i_img_data, d_img_data)
+        boot_env["initrd_high"] = cls.initrd_high
+        boot_env["fdt_high"] = cls.fdt_high
         return boot_env
 
     @classmethod
@@ -1976,8 +1980,8 @@
     # https://bugs.launchpad.net/linaro-image-tools/+bug/788765
     # for more.
     return (
-        'setenv initrd_high "0xffffffff"\n'
-        'setenv fdt_high "0xffffffff"\n'
+        'setenv initrd_high "%(initrd_high)s"\n'
+        'setenv fdt_high "%(fdt_high)s"\n'
         'setenv bootcmd "%(bootcmd)s"\n'
         'setenv bootargs "%(bootargs)s"\n'
         "boot"

=== modified file 'linaro_image_tools/media_create/tests/test_media_create.py'
--- linaro_image_tools/media_create/tests/test_media_create.py	2012-10-04 09:12:57 +0000
+++ linaro_image_tools/media_create/tests/test_media_create.py	2012-10-17 08:59:25 +0000
@@ -1693,7 +1693,9 @@
                         'console=ttyXXX  root=UUID=deadbeef rootwait ro',
             'bootcmd': 'fatload mmc 0:1 0x60000000 uImage; '
                        'fatload mmc 0:1 0x62000000 uInitrd; '
-                       'bootm 0x60000000 0x62000000'}
+                       'bootm 0x60000000 0x62000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_vexpress_a9(self):
@@ -1705,7 +1707,9 @@
                         'console=ttyXXX  root=UUID=deadbeef rootwait ro',
             'bootcmd': 'fatload mmc 0:1 0x60000000 uImage; '
                        'fatload mmc 0:1 0x62000000 uInitrd; '
-                       'bootm 0x60000000 0x62000000'}
+                       'bootm 0x60000000 0x62000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_mx51(self):
@@ -1719,7 +1723,9 @@
             'bootcmd': 'fatload mmc 0:2 0x90000000 uImage; '
                        'fatload mmc 0:2 0x92000000 uInitrd; '
                        'fatload mmc 0:2 0x91ff0000 board.dtb; '
-                       'bootm 0x90000000 0x92000000 0x91ff0000'}
+                       'bootm 0x90000000 0x92000000 0x91ff0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_smdkv310(self):
@@ -1733,7 +1739,9 @@
                         'fatload mmc 0:2 0x42000000 uInitrd; '
                         'bootm 0x40007000 0x42000000',
              'ethact': 'smc911x-0',
-             'ethaddr': '00:40:5c:26:0a:5b'}
+             'ethaddr': '00:40:5c:26:0a:5b',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_origen(self):
@@ -1745,7 +1753,9 @@
                         'rootwait ro',
              'bootcmd': 'fatload mmc 0:2 0x40007000 uImage; '
                         'fatload mmc 0:2 0x42000000 uInitrd; '
-                        'bootm 0x40007000 0x42000000'}
+                        'bootm 0x40007000 0x42000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_ux500(self):
@@ -1761,7 +1771,9 @@
                         'hwmem=48M@302M mem=152M@360M',
             'bootcmd': 'fatload mmc 1:1 0x00100000 uImage; '
                        'fatload mmc 1:1 0x08000000 uInitrd; '
-                       'bootm 0x00100000 0x08000000'}
+                       'bootm 0x00100000 0x08000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_snowball_emmc(self):
@@ -1777,7 +1789,9 @@
                         'hwmem=48M@302M mem=152M@360M',
             'bootcmd': 'fatload mmc 1:1 0x00100000 uImage; '
                        'fatload mmc 1:1 0x08000000 uInitrd; '
-                       'bootm 0x00100000 0x08000000'}
+                       'bootm 0x00100000 0x08000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_panda(self):
@@ -1798,7 +1812,9 @@
             'bootcmd': 'fatload mmc 0:1 0x80200000 uImage; '
                        'fatload mmc 0:1 0x81600000 uInitrd; '
                        'fatload mmc 0:1 0x815f0000 board.dtb; '
-                       'bootm 0x80200000 0x81600000 0x815f0000'}
+                       'bootm 0x80200000 0x81600000 0x815f0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_beagle(self):
@@ -1819,7 +1835,9 @@
             'bootcmd': 'fatload mmc 0:1 0x80000000 uImage; '
                        'fatload mmc 0:1 0x81600000 uInitrd; '
                        'fatload mmc 0:1 0x815f0000 board.dtb; '
-                       'bootm 0x80000000 0x81600000 0x815f0000'}
+                       'bootm 0x80000000 0x81600000 0x815f0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
     def test_igep(self):
@@ -1840,7 +1858,9 @@
             'bootcmd': 'fatload mmc 0:1 0x80000000 uImage; '
                        'fatload mmc 0:1 0x81600000 uInitrd; '
                        'fatload mmc 0:1 0x815f0000 board.dtb; '
-                       'bootm 0x80000000 0x81600000 0x815f0000'}
+                       'bootm 0x80000000 0x81600000 0x815f0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_cmd)
 
     def test_overo(self):
@@ -1862,7 +1882,9 @@
             'bootcmd': 'fatload mmc 0:1 0x80000000 uImage; '
                        'fatload mmc 0:1 0x81600000 uInitrd; '
                        'fatload mmc 0:1 0x815f0000 board.dtb; '
-                       'bootm 0x80000000 0x81600000 0x815f0000'}
+                       'bootm 0x80000000 0x81600000 0x815f0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertEqual(expected, boot_commands)
 
 
@@ -1958,7 +1980,9 @@
             'bootcmd': 'fatload mmc 0:1 0x80200000 uImage; '
                        'fatload mmc 0:1 0x81600000 uInitrd; '
                        'fatload mmc 0:1 0x815f0000 board.dtb; '
-                       'bootm 0x80200000 0x81600000 0x815f0000'}
+                       'bootm 0x80200000 0x81600000 0x815f0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertBootEnv(config, expected)
 
     def test_android_snowball_sd(self):
@@ -1971,7 +1995,9 @@
             'bootcmd': 'fatload mmc 1:1 0x00100000 uImage; '
                        'fatload mmc 1:1 0x05000000 uInitrd; '
                        'fatload mmc 1:1 0x8000000 board.dtb; '
-                       'bootm 0x00100000 0x05000000 0x8000000'}
+                       'bootm 0x00100000 0x05000000 0x8000000',
+            'fdt_high': '0x05000000',
+            'initrd_high': '0x06000000'}
         self.assertBootEnv(
             android_boards.AndroidSnowballSdConfig, expected)
 
@@ -1985,7 +2011,9 @@
             'bootcmd': 'fatload mmc 0:2 0x00100000 uImage; '
                        'fatload mmc 0:2 0x05000000 uInitrd; '
                        'fatload mmc 0:2 0x8000000 board.dtb; '
-                       'bootm 0x00100000 0x05000000 0x8000000'}
+                       'bootm 0x00100000 0x05000000 0x8000000',
+            'fdt_high': '0x05000000',
+            'initrd_high': '0x06000000'}
         self.assertBootEnv(
             android_boards.AndroidSnowballEmmcConfig, expected)
 
@@ -1995,7 +2023,9 @@
                         'rootwait ro init=/init androidboot.console=ttySAC2',
             'bootcmd': 'fatload mmc 0:2 0x40007000 uImage; '
                        'fatload mmc 0:2 0x42000000 uInitrd; '
-                       'bootm 0x40007000 0x42000000'}
+                       'bootm 0x40007000 0x42000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertBootEnv(
             android_boards.AndroidOrigenConfig, expected)
 
@@ -2005,7 +2035,9 @@
                         'rootwait ro init=/init androidboot.console=ttyAMA0',
             'bootcmd': 'fatload mmc 0:1 0x60000000 uImage; '
                        'fatload mmc 0:1 0x62000000 uInitrd; '
-                       'bootm 0x60000000 0x62000000'}
+                       'bootm 0x60000000 0x62000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertBootEnv(
             android_boards.AndroidVexpressConfig, expected)
 
@@ -2017,7 +2049,9 @@
                         'androidboot.console=ttymxc0',
             'bootcmd': 'fatload mmc 0:2 0x70000000 uImage; '
                        'fatload mmc 0:2 0x72000000 uInitrd; '
-                       'bootm 0x70000000 0x72000000'}
+                       'bootm 0x70000000 0x72000000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertBootEnv(
             android_boards.AndroidMx53LoCoConfig, expected)
 
@@ -2030,7 +2064,9 @@
             'bootcmd': 'fatload mmc 0:2 0x10000000 uImage; '
                        'fatload mmc 0:2 0x12000000 uInitrd; '
                        'fatload mmc 0:2 0x11ff0000 board.dtb; '
-                       'bootm 0x10000000 0x12000000 0x11ff0000'}
+                       'bootm 0x10000000 0x12000000 0x11ff0000',
+            'fdt_high': '0xffffffff',
+            'initrd_high': '0xffffffff'}
         self.assertBootEnv(
             android_boards.AndroidMx6QSabreliteConfig, expected)
 
@@ -2213,7 +2249,8 @@
         self.assertEqual(expected, fixture.mock.commands_executed)
 
     def test_get_plain_boot_script_contents(self):
-        boot_env = {'bootargs': 'mybootargs', 'bootcmd': 'mybootcmd'}
+        boot_env = {'bootargs': 'mybootargs', 'bootcmd': 'mybootcmd',
+                    'initrd_high': '0xffffffff', 'fdt_high': '0xffffffff'}
         boot_script_data = get_plain_boot_script_contents(boot_env)
         self.assertEqual(textwrap.dedent("""\
             setenv initrd_high "0xffffffff"
@@ -2230,7 +2267,8 @@
         fixture = self._mock_Popen()
         boot_script_path = os.path.join(tempdir, 'boot.scr')
         plain_boot_script_path = os.path.join(tempdir, 'boot.txt')
-        boot_env = {'bootargs': 'mybootargs', 'bootcmd': 'mybootcmd'}
+        boot_env = {'bootargs': 'mybootargs', 'bootcmd': 'mybootcmd',
+                    'initrd_high': '0xffffffff', 'fdt_high': '0xffffffff'}
         make_boot_script(boot_env, boot_script_path)
         expected = [
             '%s cp /tmp/random-abxzr %s' % (